package jiaowuxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong"
	"shylinux.com/x/education/src/jiaowuxitong/model"
)

type Table struct {
	gonganxitong.Table
	list string `name:"list class_uid uid auto" role:"void"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.CLASS_TYPE:
		for k, v := range ClassTypeList {
			m.Push(arg[0], k).Push(model.NAME, v)
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	case model.USER_CLASS_ROLE:
		for k, v := range UserClassRoleList {
			if k != UserClassCreator && k != UserClassVisitor {
				m.Push(arg[0], k).Push(model.NAME, v)
			}
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		kit.If(key == model.CLASS_TYPE, func() { value = ClassType(kit.Int(value)).String() })
		kit.If(key == model.USER_CLASS_ROLE, func() { value = UserClassRole(kit.Int(value)).String() })
		return value
	})
	return s.Table.RewriteAppend(m)
}
func (s Table) checkRole(m *ice.Message, arg ...UserClassRole) bool {
	kit.If(len(arg) == 0, func() { arg = append(arg, UserClassTeacher) })
	role := UserClassRole(kit.Int(m.Cmd(userClass{}, s.Select, m.OptionSimple(model.CLASS_UID, model.USER_UID)).Append(model.ROLE)))
	for _, v := range append(arg, UserClassCreator) {
		if role == v {
			return true
		}
	}
	return !m.WarnNotRight(true, role.String())
}
func (s Table) recordEvent(m *ice.Message, info string, arg ...string) *ice.Message {
	s.Table.RecordEvent(m, m.Option(model.CLASS_UID), info, kit.Select(m.Option(model.UID), arg, 0))
	return m
}

type Tables struct {
	Table
	portal string `data:"true"`
}

func (s Tables) BeforeMigrate(m *ice.Message, arg ...string) {}
