package model

import "shylinux.com/x/mysql-story/src/db"

const (
	UID             = "uid"
	NAME            = "name"
	TYPE            = "type"
	ROLE            = "role"
	TITLE           = "title"
	CONTENT         = "content"
	USER_UID        = "user_uid"
	USER_CLASS_ROLE = "user_class_role"
	CLASS_UID       = "class_uid"
	CLASS_NAME      = "class_name"
	CLASS_TYPE      = "class_type"
	SCHOOL_UID      = "school_uid"
	SCHOOL_NAME     = "school_name"
	CITY_UID        = "city_uid"
	GRADE           = "grade"
)

type UserClass struct {
	db.ModelWithUID
	UserUID  string `gorm:"type:char(32);index"`
	ClassUID string `gorm:"type:char(32);index"`
	Role     uint8
}
type Class struct {
	db.ModelWithUID
	SchoolUID string `gorm:"type:char(32);index"`
	Grade     string `gorm:"type:char(32)"`
	Name      string `gorm:"type:char(64)"`
	Type      uint8
}
type School struct {
	db.ModelWithUID
	CityUID string `gorm:"type:char(32);index:idx_city"`
	Name    string `gorm:"type:char(64);index:idx_city"`
	Info    string
}
type Homework struct {
	db.ModelWithUID
	ClassUID string `gorm:"type:char(32);index"`
	UserUID  string `gorm:"type:char(32)"`
	Title    string `gorm:"type:char(64)"`
	Content  string
}

func init() { db.CmdModels("", &UserClass{}, &Class{}, &School{}, &Homework{}) }
